#include "I2C_LIB.H"

// sending a byte to EEPROM
void Send_byte(unsigned char Data)
{
	 unsigned char BitCounter=8; // 8 bits in a BYTE
	do{ 
	 SCL=0;
	 NOP;
	 if((Data & 0x80)==0x80)  // detcting is it 1 or 0
	    SDA=1;
	 else
		SDA=0;
	 SCL=1;
	 Data=Data<<1; // shifting left
	 BitCounter--;
	 }while(BitCounter);
	 SCL=0;
}


// reading 1 byte from EEPROM
unsigned char  Read(void)
{
	unsigned char temp=0;
    unsigned BitCounter=8;
	SDA=1;
	do{
		SCL=0;
		NOP;
		SCL=1;
		NOP;
		if(SDA)
		temp=temp|0x01;
		else
		temp=temp&0xfe;
		if(BitCounter-1)
			temp=temp<<1;
		BitCounter--;
	  }while(BitCounter);
	return(temp);	
}


// write data to EEPROM

void WrToROM(unsigned char id,unsigned char Address,unsigned char Data)
{	
		Start();
		Send_byte(id);
		Ack();
		Send_byte(Address);
		Ack();
		Send_byte(Data);
		Ack();
		Stop();
		DelayMs(5);

}


unsigned char RdFromROM(unsigned char id,unsigned char Address)
{
unsigned char c;

		Start();
		Send_byte(id);
		Ack();
		Send_byte(Address);
		Ack();
		Start();
		Send_byte(id+1);
		Ack();
		c=Read();
		SCL=0;
        NoAck();
		Stop();
		return(c);
}


void DelayMs(unsigned int count) 
{  // mSec Delay 11.0592 Mhz 
    unsigned int i;		       		
    while(count) {
        i = 115; 
		while(i>0) i--;
        count--;
    }
}


// start condition for EEPROM
void Start(void)
{
	SDA=1;
	SCL=1;
	NOP;
	SDA=0;
	NOP;
}


// stop condition for EEPROM
void Stop(void)
{
	SDA=0;
	SCL=1;
	NOP;
	SDA=1;
	NOP;	
}


// acknowledgement for EEPROM
void Ack(void)
{
	SDA=0;
	NOP;
	SCL=1;
	NOP;
	SCL=0;
}


// no acknowledgement for EEPROM
void NoAck(void)
{
	SDA=1;
	NOP;
	SCL=1;
	NOP;
	SCL=0;	
}