Attribute VB_Name = "Module1"
Option Explicit

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long

Private Declare Function GetCommState Lib "kernel32" ( _
    ByVal nCid As Long, _
    lpDCB As DCB) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, _
    lpOverlapped As Any) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, _
    lpOverlapped As Any) As Long

Private Declare Function EscapeCommFunction Lib "kernel32" ( _
    ByVal nCid As Long, _
    ByVal nFunc As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long

Private Declare Function SetCommState Lib "kernel32" ( _
    ByVal hCommDev As Long, _
    lpDCB As DCB) As Long

Private Declare Function ClearCommError Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpErrors As Long, _
    lpStat As COMSTAT) As Long

Private Declare Function GetLastError Lib "kernel32" () As Long

Private Declare Function GetCommTimeouts Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpCommTimeouts As COMMTIMEOUTS) As Long

Private Declare Function SetCommTimeouts Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpCommTimeouts As COMMTIMEOUTS) As Long

Private Declare Function BuildCommDCB Lib "kernel32" Alias "BuildCommDCBA" ( _
    ByVal lpDef As String, _
    lpDCB As DCB) As Long

Private Type COMMTIMEOUTS
        ReadIntervalTimeout As Long
        ReadTotalTimeoutMultiplier As Long
        ReadTotalTimeoutConstant As Long
        WriteTotalTimeoutMultiplier As Long
        WriteTotalTimeoutConstant As Long
End Type

Private Type COMSTAT
        fBitFields As Long 'See Comment in Win32API.Txt
        cbInQue As Long
        cbOutQue As Long
End Type


Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) _
         As Long
      Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) _
         As Long
      Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, _
         ByVal dwBytes As Long) As Long
      Declare Function CloseClipboard Lib "User32" () As Long
      Declare Function OpenClipboard Lib "User32" (ByVal hwnd As Long) _
         As Long
      Declare Function EmptyClipboard Lib "User32" () As Long
      Declare Function lstrcpy Lib "kernel32" (ByVal lpString1 As Any, _
         ByVal lpString2 As Any) As Long
      Declare Function SetClipboardData Lib "User32" (ByVal wFormat _
         As Long, ByVal hMem As Long) As Long

      Public Const GHND = &H42
      Public Const CF_TEXT = 1
      Public Const MAXSIZE = 4096
      
      
Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
Const OPEN_EXISTING = 3
Const INVALID_HANDLE_VALUE = -1

Private Type DCB
        DCBlength As Long
        BaudRate As Long
        fBitFields As Long 'See Comments in Win32API.Txt
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        Parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved1 As Integer 'Reserved; Do Not Use
End Type

Dim hCom As Long
Dim d As DCB
Dim cto As COMMTIMEOUTS
Dim r As Boolean
Dim errors As Long
Dim byteswritten As Long, bytesread As Long
Dim i As Long

Private Type Buffer
   msg(301) As Byte
End Type

Public Function portclose()
  CloseHandle hCom
End Function

Public Function portini() As Long
    hCom = CreateFile(Form1.Combo1.Text, GENERIC_READ Or GENERIC_WRITE, ByVal 0, ByVal 0, OPEN_EXISTING, ByVal 0, ByVal 0)
    If hCom = INVALID_HANDLE_VALUE Then
    MsgBox "Port Is Already Open Or Invalid No", 0, "Error"

    Else

    r = BuildCommDCB("baud=9600 parity=n data=8 stop=1 ", d)
    r = SetCommState(hCom, d)
    cto.ReadIntervalTimeout = &HFFFF
    cto.ReadTotalTimeoutMultiplier = 0
    cto.ReadTotalTimeoutConstant = 0
    r = SetCommTimeouts(hCom, cto)
    End If
portini = hCom
End Function

Public Function portsend(msg As String)
Dim w As Long, r As Long
r = WriteFile(hCom, ByVal msg, Len(msg), w, ByVal 0)
End Function

Public Function portrec()
Dim msg As Buffer
Dim w As Long, r As Long
r = ReadFile(hCom, ByVal msg, 300, w, ByVal 0)
If w > 0 Then
For i = 0 To w - 1
       Form1.Text3.Text = Form1.Text3.Text & Chr(msg.msg(i))
   Next
End If
End Function

Public Function available_ports()
Dim i As Integer          'loop counter

For i = 1 To 20
hCom = CreateFile("COM" & i, GENERIC_READ Or GENERIC_WRITE, ByVal 0, ByVal 0, OPEN_EXISTING, ByVal 0, ByVal 0)
If hCom <> INVALID_HANDLE_VALUE Then
Form1.Combo1.AddItem "COM" & i
portclose
End If
Next i
End Function

 Function ClipBoard_SetData(MyString As String)
         Dim hGlobalMemory As Long, lpGlobalMemory As Long
         Dim hClipMemory As Long, X As Long

         ' Allocate movable global memory.
         '-------------------------------------------
         hGlobalMemory = GlobalAlloc(GHND, Len(MyString) + 1)

         ' Lock the block to get a far pointer
         ' to this memory.
         lpGlobalMemory = GlobalLock(hGlobalMemory)

         ' Copy the string to this global memory.
         lpGlobalMemory = lstrcpy(lpGlobalMemory, MyString)

         ' Unlock the memory.
         If GlobalUnlock(hGlobalMemory) <> 0 Then
            MsgBox "Could not unlock memory location. Copy aborted."
            GoTo ExitHere
         End If

         ' Open the Clipboard to copy data to.
         If OpenClipboard(0&) = 0 Then
            MsgBox "Could not open the Clipboard. Copy aborted."
            Exit Function
         End If

         ' Clear the Clipboard.
         X = EmptyClipboard()

         ' Copy the data to the Clipboard.
         hClipMemory = SetClipboardData(CF_TEXT, hGlobalMemory)

ExitHere:

         If CloseClipboard() = 0 Then
            MsgBox "Could not close Clipboard."
         End If

         End Function
         
